import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { Type } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { IHasHighLowValueCategory } from "./IHasHighLowValueCategory";
import { RangeCategoryFramePreparer } from "./RangeCategoryFramePreparer";
import { CategoryMode } from "./CategoryMode";
import { ICategoryScaler } from "./ICategoryScaler";
import { IScaler } from "./IScaler";
import { IBucketizer } from "./IBucketizer";
import { CategorySeriesView } from "./CategorySeriesView";
import { CategoryFrame } from "./CategoryFrame";
import { SeriesView } from "./SeriesView";
import { List$1 } from "igniteui-react-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { Polyline } from "igniteui-react-core";
import { Polygon } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { Rect } from "igniteui-react-core";
import { Axis } from "./Axis";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { RenderSurface } from "./RenderSurface";
import { ValueCollisionMode } from "./ValueCollisionMode";
import { ChartSelection } from "./ChartSelection";
import { SeriesSelectionBehavior } from "./SeriesSelectionBehavior";
/**
 * @hidden
 */
export declare class RangeCategoryBucketCalculator extends CategoryBucketCalculator {
    static $t: Type;
    j: RangeCategorySeriesView;
    constructor(a: RangeCategorySeriesView);
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
    private l;
    private k;
    private i;
    private h;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class RangeCategorySeries extends CategorySeries implements IIsCategoryBased, IHasHighLowValueCategory {
    static $t: Type;
    protected cs(): SeriesView;
    getHostReferenceValue(): number;
    qz(a: SeriesView): void;
    aas: RangeCategorySeriesView;
    constructor();
    private _RangeFramePreparer;
    get RangeFramePreparer(): RangeCategoryFramePreparer;
    set RangeFramePreparer(a: RangeCategoryFramePreparer);
    aa5: string;
    protected gb(): boolean;
    protected ht(): List$1<SeriesLayerPropertyOverlay>;
    private aa8;
    private aa7;
    kq(a: any, b: string): any;
    md(a: string): string;
    get lowColumn(): IFastItemColumn$1<number>;
    set lowColumn(a: IFastItemColumn$1<number>);
    private aau;
    aa2: string;
    get highColumn(): IFastItemColumn$1<number>;
    set highColumn(a: IFastItemColumn$1<number>);
    private aat;
    aa0: string;
    aay: string;
    protected y2(): CategoryTransitionInMode;
    aai(a: CategoryFrame, b: CategorySeriesView): void;
    protected aa9(a: Polyline, b: Polygon, c: Polyline, d: number, e: List$1<number[]>, f: boolean): void;
    az(a: Rect): AxisRange;
    gd(a: any): boolean;
    protected q7(a: any, b: string, c: any, d: any): void;
    ay(a: Axis): AxisRange;
    protected pb(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    he(a: Rect, b: Rect, c: SeriesView): boolean;
    aaf(a: CategoryFrame, b: CategorySeriesView): void;
    get currentCategoryMode(): CategoryMode;
    get scaler(): ICategoryScaler;
    get yScaler(): IScaler;
    get bucketizer(): IBucketizer;
    get currentMode2Index(): number;
    provideCollisionDetector(): IDetectsCollisions;
    get mayContainUnknowns(): boolean;
    rr(a: Rect, b: RenderSurface): void;
    private aaq;
    ro(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    iy(): number;
    aab(a: ValueCollisionMode, b: List$1<ChartSelection>, c: number, d: number, e: number, f: number, g: SeriesSelectionBehavior): void;
    z5(a: List$1<ChartSelection>, b: number, c: SeriesSelectionBehavior): void;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class RangeCategorySeriesView extends CategorySeriesView {
    static $t: Type;
    c5: RangeCategorySeries;
    constructor(a: RangeCategorySeries);
    c6(a: Polyline, b: Polygon, c: Polyline, d: number, e: List$1<number[]>, f: boolean): void;
    cx(): CategoryBucketCalculator;
}
